<?php

if (!function_exists('sv') || preg_match('#plugins/eventcal/index.php#i', $_SERVER['SCRIPT_NAME']))
{
	die('no direct access');
}

/*
============================================================
CMSimple Plugin EventCalendar
============================================================
Version:    EventCalendar 1.3
Released:   2023-01
Copyright:  Gert Ebersbach - www.ge-webdesign.de
============================================================ 
License:
- free for noncommercial websites
- fee required for commercial websites
============================================================ 
utf-8 check: äöü 
*/

if(!isset($_SESSION)){session_start();}


// setzt Sessionvariable für Monatsermittlung, wenn es diese noch nicht gibt

if(!isset($_SESSION['evcal_month_timestamp']))
{
	set_evcalMonthSession();
}


// Setzt Sessionvariable abhängig von Timestamp aus GET Variable

if(isset($_GET['evcaltimestamp']) && $_GET['evcaltimestamp'] != '')
{
	$_SESSION['evcal_month_timestamp'] = $_GET['evcaltimestamp'];
}
else // setzt Sessionvariable auf aktuellen Monat, wenn der entsprechende Link geklickt wird.
{
	if(isset($_GET['evcalmonth']) && $_GET['evcalmonth'] == 'today') // wenn heute-Link geklickt wird
	{
		set_evcalMonthSession();
	}
}


// Timestamp für die Monatsermittlung

if(isset($_REQUEST['evcaltimestamp'])) 
{
	$evcalMonthTimestamp = $_REQUEST['evcaltimestamp'];
}
else 
{
	$evcalMonthTimestamp = $_SESSION['evcal_month_timestamp'];
}


$arrMonth = array(
"January" => $plugin_tx['eventcal']['month_jan'],
"February" => $plugin_tx['eventcal']['month_feb'],
"March" => $plugin_tx['eventcal']['month_mar'],
"April" => $plugin_tx['eventcal']['month_apr'],
"May" => $plugin_tx['eventcal']['month_may'],
"June" => $plugin_tx['eventcal']['month_jun'],
"July" => $plugin_tx['eventcal']['month_jul'],
"August" => $plugin_tx['eventcal']['month_aug'],
"September" => $plugin_tx['eventcal']['month_sep'],
"October" => $plugin_tx['eventcal']['month_oct'],
"November" => $plugin_tx['eventcal']['month_nov'],
"December" => $plugin_tx['eventcal']['month_dec']
);
    
$headline = array(
$plugin_tx['eventcal']['weekday_mon'],
$plugin_tx['eventcal']['weekday_tue'],
$plugin_tx['eventcal']['weekday_wed'],
$plugin_tx['eventcal']['weekday_thu'],
$plugin_tx['eventcal']['weekday_fri'],
$plugin_tx['eventcal']['weekday_sat'],
$plugin_tx['eventcal']['weekday_sun']
);





/*
#######################################
         F U N C T I O N S
#######################################
*/

function set_evcalMonthSession()
{
	if(date('d') < 16) // in der 1. Monatshälfte: plus 6 Tage
	{
		$_SESSION['evcal_month_timestamp'] = time() + 518400;
	}
	else // in der 2. Monatshälfte: minus 6 Tage
	{
		$_SESSION['evcal_month_timestamp'] = time() - 518400;
	}
}

function evcal_monthBack($evcaltimestamp)
{
	return mktime(0,0,0, date("m",$evcaltimestamp)-1,date("d",$evcaltimestamp),date("Y",$evcaltimestamp));
}


function evcal_yearBack($evcaltimestamp)
{
	return mktime(0,0,0, date("m",$evcaltimestamp),date("d",$evcaltimestamp),date("Y",$evcaltimestamp)-1);
}


function evcal_monthForward($evcaltimestamp)
{
	return mktime(0,0,0, date("m",$evcaltimestamp)+1,date("d",$evcaltimestamp),date("Y",$evcaltimestamp));
}


function evcal_yearForward($evcaltimestamp)
{
	return mktime(0,0,0, date("m",$evcaltimestamp),date("d",$evcaltimestamp),date("Y",$evcaltimestamp)+1);
}


function evcal_getCalender($evcalMonthTimestamp,$evcalObject='',$headline = array('Mo','Di','Mi','Do','Fr','Sa','So')) 
{
	global $pth,$plugin_tx;
	
	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}
	
	$sum_days = date('t',$_SESSION['evcal_month_timestamp']);
	$LastMonthSum = date('t',$_SESSION['evcal_month_timestamp'] - 2332800);
    
	$o = "\n" . '<div class="days_headline">' . "\n";
	foreach( $headline as $key => $value ) 
	{
		$o.= '<div class="day"><div class="dayin">' . $value . '</div></div>' . "\n";
	}
	$o.= '<div style="clear: both;"></div>
</div>
';
    
	for( $i = 1; $i <= $sum_days; $i++ ) 
	{
		$day_name = date('D',mktime(0,0,0,date('m',$evcalMonthTimestamp),$i,date('Y',$evcalMonthTimestamp)));
		$day_number = date('w',mktime(0,0,0,date('m',$evcalMonthTimestamp),$i,date('Y',$evcalMonthTimestamp)));
        
		if( $i == 1) 
		{
			$s = array_search($day_name,array('Mon','Tue','Wed','Thu','Fri','Sat','Sun'));
			for( $b = $s; $b > 0; $b-- ) 
			{
				$x = $LastMonthSum - $b+1;
				$o.= '<div class="day"><div class="dayin prevnextmonth">' . sprintf("%02d",$x) . '</div></div>' . "\n";
			}
		}
		
		if($i == date('d',time()) && date('m.Y',$evcalMonthTimestamp) == date('m.Y') && !strpos(file_get_contents($pth['file']['content']), $evcalObject . ':' . date('Ym',$evcalMonthTimestamp) . sprintf("%02d",$i)))
		{
			$o.= '<div class="day" title="' . $plugin_tx['eventcal']['day_tooltipp_today'] . '"><div class="dayin normal current">' . (sprintf("%02d",$i) + 0) . '</div></div>' . "\n";
		} 
		elseif($i == date('d',time()) && date('m.Y',$evcalMonthTimestamp) == date('m.Y') && strpos(file_get_contents($pth['file']['content']), $evcalObject . ':' . date('Ym',$evcalMonthTimestamp) . sprintf("%02d",$i)))
		{
			$o.= '<a href="?&amp;search=' . str_replace(' ','_',$evcalObject) . '&#58;' . date('Ym',$evcalMonthTimestamp) . sprintf("%02d",$i) . '&amp;function=search&amp;evcaltimestamp=' . $evcalMonthTimestamp . '"><div class="day"><div title="' . $plugin_tx['eventcal']['day_tooltipp_today'] . ' - ' . $plugin_tx['eventcal']['day_tooltipp_searchevents'] . '" class="dayin event current">' . (sprintf("%02d",$i) + 0) . '</div></div></a>' . "\n";
		} 
		elseif(strpos(file_get_contents($pth['file']['content']), $evcalObject . ':' . date('Ym',$evcalMonthTimestamp) . sprintf("%02d",$i)))
		{
			$o.= '<a href="?&amp;search=' . str_replace(' ','_',$evcalObject) . '&#58;' . date('Ym',$evcalMonthTimestamp) . sprintf("%02d",$i) . '&amp;function=search&amp;evcaltimestamp=' . $evcalMonthTimestamp . '"><div class="day"><div title="' . $plugin_tx['eventcal']['day_tooltipp_searchevents'] . '" class="dayin event">' . (sprintf("%02d",$i) + 0) . '</div></div></a>' . "\n";
		}
		else 
		{
			$o.= '<div class="day"><div class="dayin normal">' . (sprintf("%02d",$i) + 0) . '</div></div>' . "\n";
		}
        
		if( $i == $sum_days) 
		{
			$next_sum = (6 - array_search($day_name,array('Mon','Tue','Wed','Thu','Fri','Sat','Sun')));
			for( $c = 1; $c <=$next_sum; $c++) 
			{
				$o.= '<div class="day"><div class="dayin prevnextmonth">' . (sprintf("%02d",$c) + 0) . '</div></div>' . "\n"; 
			}
		}
	}
	return $o;
}

function eventCal($evcalObject='',$evcalTitle='')
{
	if(!defined('CMSIMPLE_VERSION'))
	{
		return '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
	}
	
	global $plugin_tx,$sn,$u,$s,$evcalMonthTimestamp,$headline,$arrMonth;
	
//	if($s<0)$s=0;
	$arrDaySearch = array(
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
	);

	$arrDayReplace = array(
	$plugin_tx['eventcal']['weekday_sun_long'],
	$plugin_tx['eventcal']['weekday_mon_long'],
	$plugin_tx['eventcal']['weekday_tue_long'],
	$plugin_tx['eventcal']['weekday_wed_long'],
	$plugin_tx['eventcal']['weekday_thu_long'],
	$plugin_tx['eventcal']['weekday_fri_long'],
	$plugin_tx['eventcal']['weekday_sat_long'],
	$plugin_tx['eventcal']['weekday_sun_long']
	);
	
	$arrMonthSearch = array(
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December"
	);

	$arrMonthReplace = array(
	$plugin_tx['eventcal']['month_jan'],
	$plugin_tx['eventcal']['month_feb'],
	$plugin_tx['eventcal']['month_mar'],
	$plugin_tx['eventcal']['month_apr'],
	$plugin_tx['eventcal']['month_may'],
	$plugin_tx['eventcal']['month_jun'],
	$plugin_tx['eventcal']['month_jul'],
	$plugin_tx['eventcal']['month_aug'],
	$plugin_tx['eventcal']['month_sep'],
	$plugin_tx['eventcal']['month_oct'],
	$plugin_tx['eventcal']['month_nov'],
	$plugin_tx['eventcal']['month_dec']
	);
	
	
// P L U G I N   O U T P U T 

	$eventCalOutput = '
<div id="eventCalAnchor_' . uenc($evcalObject) . '" class="eventCalAnchor">&nbsp;</div>
<div id="eventCal" class="eventCal">
	';

	if($evcalTitle != '')
	{
		$eventCalOutput.= '
<h4>' . $evcalTitle . '</h4>';
	}

// Sonderfälle sitemap mailform search
if(isset($_REQUEST['sitemap']))$evcalQueryVar = '&sitemap';
elseif(isset($_REQUEST['mailform']))$evcalQueryVar = '&mailform';
elseif(isset($_REQUEST['search']))$evcalQueryVar = '&search=' . $_REQUEST['search'] . '&function=search';
else $evcalQueryVar = '';

	$eventCalOutput.= '
<div class="eventCalIn">
<div class="pagination">
<div class="arrowsLeft"><a href="?' . ($s>=0 ? $u[$s] : $evcalQueryVar) . '&amp;evcaltimestamp=' . evcal_yearBack($evcalMonthTimestamp) . '#eventCalAnchor_' . uenc($evcalObject) . '" class="last">&laquo;</a></div>
<span>' . date('Y',$evcalMonthTimestamp) . '</span>
<div class="arrowsRight"><a href="?' . ($s>=0 ? $u[$s] : $evcalQueryVar) . '&amp;evcaltimestamp=' . evcal_yearForward($evcalMonthTimestamp) . '#eventCalAnchor_' . uenc($evcalObject) . '" class="next">&raquo;</a></div>
</div>

<div class="pagination">
<div class="arrowsLeft"><a href="?' . ($s>=0 ? $u[$s] : $evcalQueryVar) . '&amp;evcaltimestamp=' . evcal_monthBack($evcalMonthTimestamp) . '#eventCalAnchor_' . uenc($evcalObject) . '" class="last">&laquo;</a></div>
<span>' . $arrMonth[date('F',$evcalMonthTimestamp)] . '</span>
<div class="arrowsRight"><a href="?' . ($s>=0 ? $u[$s] : $evcalQueryVar) . '&amp;evcaltimestamp=' . evcal_monthForward($evcalMonthTimestamp) . '#eventCalAnchor_' . uenc($evcalObject) . '" class="next">&raquo;</a></div>
</div>

<div class="evcalTodayLink"><a href="?' . ($s>=0 ? $u[$s] : $evcalQueryVar) . '&evcalmonth=today#eventCalAnchor_' . uenc($evcalObject) . '">' . str_replace($arrDaySearch,$arrDayReplace,date('l')) . ', ' . str_replace($arrMonthSearch,$arrMonthReplace,date($plugin_tx['eventcal']['date_format'])) . '</a></div>

<div class="evcalDays">
' . 
evcal_getCalender($evcalMonthTimestamp,$evcalObject,$headline) . '
</div>
<div class="clear"></div>
</div>
</div>
';

	return $eventCalOutput;
}

function eventCalDate($evcalMonthEventcode)
{
	return '<div class="eventCalEventCode">' . str_replace(' ','_',$evcalMonthEventcode) . '</div>';
}
?>